import OFS, Globals
from Globals import Persistent
import AccessControl

class RaamatuAndmed(
   Persistent, 
   OFS.SimpleItem.Item,
   AccessControl.Role.RoleManager):
   "Klass raamatu andmete hoidmiseks"
   pealkiri=""
   autor=""
   ilmumisaasta=""
   marksonad=[]
   meta_type="RaamatuAndmed"
   
   def index_html(self):
     "Andmete vljastus veebis"
     t="<html><head><title>Raamatu andmed</title></head><body>"+\
       "Pealkiri: "+self.pealkiri+\
       "<br />Autor: "+self.autor+\
       "<br />Ilmumisaasta:"+str(self.ilmumisaasta)+\
       "<br />Mrksnad:<ul>"
     for sona in self.marksonad:
       t=t+"<li>"+sona+"</li>\n"
     t=t+"</ul></body></html>"
     return t
     
   def kysiPealkiri(self):
     "Pealkirja teatamine"
     return self.pealkiri
     
   def __init__(self, pealkiri, autor, ilmumisaasta, marksonad=[]):
     "Algvrtustamine"
     self.pealkiri=pealkiri
     self.autor=autor
     self.ilmumisaasta=ilmumisaasta
     self.marksonad=marksonad
     
Globals.InitializeClass(RaamatuAndmed)
     
def lisamisKonstruktor(lisaja):
  "Uus tervitaja"
  lisaja.Destination()._setObject("hoidla", RaamatuHoidla())
  return "Lisatud hoidla"


class RaamatuHoidla(    
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager):
       "Kataloog raamatute otsimiseks, vaatamiseks ja muutmiseks"     
       meta_type="RaamatuHoidla"
       loendur=0
       
       def lisaRaamat(self, pealkiri, autor):
         "Raamatu lisamine kataloogi"
         r=RaamatuAndmed(pealkiri, autor, 0)
         self.loendur=self.loendur+1
         tunnus="raamat"+str(self.loendur)
         r.id=tunnus
         self._setObject(tunnus, r)
         return "Raamat edukalt lisatud"
         
       def loendaRaamatuid(self):
         "Teatab hoidlas olevate raamatute koguse"
         kogus=len(self.objectValues('RaamatuAndmed'))
         return "Raamatuid kokku "+str(kogus)
     