import OFS, Globals
from Globals import Persistent
import AccessControl

class RaamatuAndmed(
   Persistent, 
   OFS.SimpleItem.Item,
   AccessControl.Role.RoleManager):
   "Klass raamatu andmete hoidmiseks"
   pealkiri=""
   autor=""
   ilmumisaasta=""
   marksonad=[]
   meta_type="RaamatuAndmed"
   
   def index_html(self):
     "Andmete vljastus veebis"
     t="<html><head><title>Raamatu andmed</title></head><body>"+\
       "Pealkiri: "+self.pealkiri+\
       "<br />Autor: "+self.autor+\
       "<br />Ilmumisaasta:"+str(self.ilmumisaasta)+\
       "<br />Mrksnad:<ul>"
     for sona in self.marksonad:
       t=t+"<li>"+sona+"</li>\n"
     t=t+"</ul><br /><a href='muutmisVorm'>muuda</a>"+\
          "</body></html>"
     return t
     
   def muutmisVorm(self):
     "Vorm andmete muutmiseks"
     t="<html><head><title>Raamatu andmed</title></head><body>"+\
       "<form action='muutmisLeht'>"+\
       "Pealkiri: <input type='text' name='pealkiri' value='"+\
       self.pealkiri+"' /><br />\n"
     t=t+"Autor: <input type='text' name='autor' value='"+\
       self.autor+"' /><br />\n"
     t=t+"Ilmumisaasta: <input type='text' name='ilmumisaasta' value='"+\
       str(self.ilmumisaasta)+"' /><br />\n"
     t=t+"<h3>Mrksnad</h3>"
     for sona in self.marksonad:
       t=t+"<input type='text' name='marksona' value='"+sona+"' /><br />\n"
     for i in range(3):
       t=t+"<input type='text' name='marksona'  /><br />\n"

     t=t+"<input type='submit' value='saada' /></form></body></html>"
     return t
     
   def muutmisLeht(self, REQUEST, pealkiri, autor, ilmumisaasta, marksona):
     "Leht andmete salvestamiseks"
     self.pealkiri=pealkiri
     self.autor=autor
     self.ilmumisaasta=ilmumisaasta
     self.marksonad=[]
     for sona in marksona:
       if len(sona)>0:
         self.marksonad.append(sona)
     REQUEST.RESPONSE.redirect('index_html')
     
   def kysiPealkiri(self):
     "Pealkirja teatamine"
     return self.pealkiri
     
   def __init__(self, pealkiri, autor, ilmumisaasta, marksonad=[]):
     "Algvrtustamine"
     self.pealkiri=pealkiri
     self.autor=autor
     self.ilmumisaasta=ilmumisaasta
     self.marksonad=marksonad
     
Globals.InitializeClass(RaamatuAndmed)
     
def lisamisKonstruktor(lisaja):
  "Uus tervitaja"
  lisaja.Destination()._setObject("hoidla", RaamatuHoidla())
  return "Lisatud hoidla"


class RaamatuHoidla(    
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager):
       "Kataloog raamatute otsimiseks, vaatamiseks ja muutmiseks"     
       meta_type="RaamatuHoidla3"
       loendur=0
       
       def lisaRaamat(self, pealkiri, autor):
         "Raamatu lisamine kataloogi"
         r=RaamatuAndmed(pealkiri, autor, 0)
         self.loendur=self.loendur+1
         tunnus="raamat"+str(self.loendur)
         r.id=tunnus
         self._setObject(tunnus, r)
         return "Raamat edukalt lisatud"
         
       def loendaRaamatuid(self):
         "Teatab hoidlas olevate raamatute koguse"
         kogus=len(self.objectValues('RaamatuAndmed'))
         return "Raamatuid kokku "+str(kogus)
     
