import OFS, Globals
from Globals import Persistent
import AccessControl

class RaamatuAndmed(
   Persistent, 
   OFS.SimpleItem.Item,
   AccessControl.Role.RoleManager):
   "Klass raamatu andmete hoidmiseks"
   pealkiri=""
   autor=""
   ilmumisaasta=""
   marksonad=[]
   meta_type="RaamatuAndmed"
   
   def index_html(self):
     "Andmete vljastus veebis"
     t="<html><head><title>Raamatu andmed</title></head><body>"+\
       "Pealkiri: "+self.pealkiri+\
       "<br />Autor: "+self.autor+\
       "<br />Ilmumisaasta:"+str(self.ilmumisaasta)+\
       "<br />Mrksnad:<ul>"
     for sona in self.marksonad:
       t=t+"<li>"+sona+"</li>\n"
     t=t+"</ul><br /><a href='muutmisVorm'>muuda</a>"+\
          "</body></html>"
     return t
     
   def muutmisVorm(self):
     "Vorm andmete muutmiseks"
     t="<html><head><title>Raamatu andmed</title></head><body>"+\
       "<form action='muutmisLeht'>"+\
       "Pealkiri: <input type='text' name='pealkiri' value='"+\
       self.pealkiri+"' /><br />\n"
     t=t+"Autor: <input type='text' name='autor' value='"+\
       self.autor+"' /><br />\n"
     t=t+"Ilmumisaasta: <input type='text' name='ilmumisaasta' value='"+\
       str(self.ilmumisaasta)+"' /><br />\n"
     t=t+"<h3>Mrksnad</h3>"
     for sona in self.marksonad:
       t=t+"<input type='text' name='marksona' value='"+sona+"' /><br />\n"
     for i in range(3):
       t=t+"<input type='text' name='marksona'  /><br />\n"

     t=t+"<input type='submit' value='saada' /></form></body></html>"
     return t
     
   def muutmisLeht(self, REQUEST, pealkiri, autor, ilmumisaasta, marksona):
     "Leht andmete salvestamiseks"
     self.pealkiri=pealkiri
     self.autor=autor
     self.ilmumisaasta=ilmumisaasta
     self.marksonad=[]
     for sona in marksona:
       if len(sona)>0:
         self.marksonad.append(sona)
     REQUEST.RESPONSE.redirect('index_html')
     
   def kysiPealkiri(self):
     "Pealkirja teatamine"
     return self.pealkiri
     
   def kysiAutor(self):
     "Autori ksimine"
     return self.autor
     
   def kysiIlmumisaasta(self):
     "Ilmumisaasta ksimine"
     try:
       return int(self.ilmumisaasta)
     except:
       return 0
       
   def kysiMarksonad(self):
     "Mrksnade ksimine"
     return self.marksonad
     
   def __init__(self, pealkiri, autor, ilmumisaasta, marksonad=[]):
     "Algvrtustamine"
     self.pealkiri=pealkiri
     self.autor=autor
     self.ilmumisaasta=ilmumisaasta
     self.marksonad=marksonad
     
Globals.InitializeClass(RaamatuAndmed)
     
def lisamisKonstruktor(lisaja):
  "Uus tervitaja"
  lisaja.Destination()._setObject("hoidla", RaamatuHoidla())
  return "Lisatud hoidla"


class RaamatuHoidla(    
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager):
       "Kataloog raamatute otsimiseks, vaatamiseks ja muutmiseks"     
       meta_type="RaamatuHoidla5"
       loendur=0
       
       def lisaRaamat(self, pealkiri, autor, aasta):
         "Raamatu lisamine kataloogi"
         r=RaamatuAndmed(pealkiri, autor, int(aasta))
         self.loendur=self.loendur+1
         tunnus="raamat"+str(self.loendur)
         r.id=tunnus
         self._setObject(tunnus, r)
         return "Raamat edukalt lisatud"
         
       def lisamisVorm(self):
         "Vorm raamatute lisamiseks"
         t="<html><head><title>Lisamisvorm</title></head>\n"+\
           "<body><form action='lisaRaamat' >"+\
           "Pealkiri: <input type='text' name='pealkiri' /><br />"+\
           "Autor: <input type='text' name='autor' /><br />"+\
           "Ilmumisaasta: <input type='text' name='aasta' /><br />"+\
           "<input type='submit' value='Lisa' /></form></body></html>"
         return t
         
       def loendaRaamatuid(self):
         "Teatab hoidlas olevate raamatute koguse"
         kogus=len(self.objectValues('RaamatuAndmed'))
         return "Raamatuid kokku "+str(kogus)
         
       def raamatuteLoetelu(self):
         "Raamatute andmed tabelina"
         t="<html><head><title>Loetelu</title></head>\n<body>"
         t=t+"<table><tr><td>Pealkiri</td><td>Autor</td></tr>"
         m=self.objectValues('RaamatuAndmed')
         for raamat in m:
           t=t+"<tr><td>"+raamat.kysiPealkiri()+"</td><td>"+\
                    raamat.kysiAutor()+"</td><td>"+\
                    str(raamat.kysiIlmumisaasta())+"</td></tr>\n"
         t=t+"</table></body></html>"
         return t
         
       def raamatuteOtsing(self, otsitavAutor="", otsitavPealkiri="", 
             vahimIlmumisaasta=0, suurimIlmumisaasta=10000, 
             otsitavMarksona=""):
         "Raamatute andmed tabelina"
         t="<html><head><title>Loetelu</title></head>\n<body>"
         t=t+"<form><table><tr><td>Pealkiri</td><td>Autor</td></tr>"
         m=self.objectValues('RaamatuAndmed')
         for raamat in m:
          if self.kasSobibOtsingusse(raamat, otsitavAutor, otsitavPealkiri,
           vahimIlmumisaasta, suurimIlmumisaasta, otsitavMarksona):
           t=t+"<tr><td><a href='"+raamat.id+"'>"+raamat.kysiPealkiri()+"</a></td><td>"+\
                    raamat.kysiAutor()+"</td><td>"+\
                    str(raamat.kysiIlmumisaasta())+"</td></tr>\n"
         t=t+"</table>"
         t=t+"Autori nime algus: <input type='text' name='otsitavAutor' /><br />"
         t=t+"Pealkirja algus: <input type='text' name='otsitavPealkiri' /><br />"
         t=t+"Ilmumisaasta algus: <input type='text' name='vahimIlmumisaasta' /><br />"
         t=t+"Ilmumisaasta ots: <input type='text' name='suurimIlmumisaasta' /><br />"
         t=t+"Mrksna: <input type='text' name='otsitavMarksona' /><br />"
         t=t+"<input type='submit' value='Otsi' /><br />"
         t=t+"</form></body></html>"
         return t

       def kasSobibOtsingusse(self, raamat, otsitavAutor, otsitavPealkiri,
            vahimIlmumisaasta, suurimIlmumisaasta, otsitavMarksona):
          "Otsingu abifunktsioon, kus teatatakse, kas raamat vastab tingimustele"
          if not raamat.kysiAutor().startswith(otsitavAutor):
            return 0
          if not raamat.kysiPealkiri().startswith(otsitavPealkiri):
            return 0
          if raamat.kysiIlmumisaasta() and vahimIlmumisaasta:
            if int(vahimIlmumisaasta)>raamat.kysiIlmumisaasta():
              return 0
          if raamat.kysiIlmumisaasta() and suurimIlmumisaasta:
            if int(suurimIlmumisaasta)<raamat.kysiIlmumisaasta():
              return 0
          if otsitavMarksona:
            m=raamat.kysiMarksonad()
            sonaLeitud=0
            for sona in m:
              if otsitavMarksona==sona:
                sonaLeitud=1
            if not sonaLeitud:
              return 0

          return 1

Globals.InitializeClass(RaamatuHoidla)    
